<?php

class bdImage_XenForo_DataWriter_Forum extends XFCP_bdImage_XenForo_DataWriter_Forum
{
    protected function _getFields()
    {
        $fields = parent::_getFields();

        $fields['xf_forum']['bdimage_last_post_image'] = array(
            'type' => XenForo_DataWriter::TYPE_STRING,
            'default' => ''
        );

        return $fields;
    }

    public function updateCountersAfterDiscussionSave(XenForo_DataWriter_Discussion $discussionDw, $forceInsert = false)
    {
        parent::updateCountersAfterDiscussionSave($discussionDw, $forceInsert);

        if ($this->get('last_post_id') == $discussionDw->get('last_post_id')) {
            // the last post info has been updated with data from the thread
            // we will copy the thread's image too
            $this->set('bdimage_last_post_image', $discussionDw->get('bdimage_image'));
        }
    }

    public function updateLastPost()
    {
        parent::updateLastPost();

        if ($this->get('last_post_id') > 0) {
            // the parent implementation will call
            // XenForo_Model_Thread::getLastUpdatedThreadInForum itself
            // but the result is cached so we don't make much impact here by calling it again
            /** @var XenForo_Model_Thread $attachmentModel */
            $attachmentModel = $this->getModelFromCache('XenForo_Model_Thread');
            $lastPost = $attachmentModel->getLastUpdatedThreadInForum($this->get('node_id'));

            if ($lastPost) {
                $this->set('bdimage_last_post_image', $lastPost['bdimage_image']);
            }
        }
    }

}
